/* štruktúra obsahujúca vlastnosti daného priestoru buniek */
typedef struct
{
    int2 size;
    int wrap;//1 ak je priestor uzatvorený sám do seba
}_cellspace_prop;

typedef float _time;
typedef float _state;

/* event je dátový typ obsahujúci čas kedy nastala udalosť a nový stav  */
typedef struct
{
    _time x;
    _state y;
}_event;

/* cell je dátový typ obsahujúci radu  */
typedef struct
{
    int start,end;//začiatočná a koncová pozícia. ak sa start a end rovnajú obsahuje rada poslednú povinnú položku.
    int start2,end2;//start a start2 sa budu musiet pokazde prekopirovat kvoly konzistencii pri zapise do nich.
    _event events[QUEUE_LEN];
}_cell;
